/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import com.rjconsultores.ventaboletos.entidad.ComisionistaExterno;
import com.rjconsultores.ventaboletos.service.ComisionistaExternoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("editarComisionistaExternoController")
@Scope("prototype")
public class EditarComisionistaExternoController extends MyGenericForwardComposer {

    @Autowired
    private ComisionistaExternoService comisionistaExternoService;
    private ComisionistaExterno comisionistaExterno;
    private MyListbox comisionistaExternoList;
    private Textbox txtNome;
    private Button btnApagar;
    private static Logger log = Logger.getLogger(EditarComisionistaExternoController.class);

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public ComisionistaExterno getComisionistaExterno() {
        return comisionistaExterno;
    }

    public void setComisionistaExterno(ComisionistaExterno comisionistaExterno) {
        this.comisionistaExterno = comisionistaExterno;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        comisionistaExterno =
                (ComisionistaExterno) Executions.getCurrent().getArg().get("comisionistaExterno");
        comisionistaExternoList =
                (MyListbox) Executions.getCurrent().getArg().get("comisionistaExternoList");

        if (comisionistaExterno.getComisionistaexternoId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) {
        txtNome.getValue();

        try {
            comisionistaExterno.setActivo(true);
            comisionistaExterno.setFecmodif(Calendar.getInstance().getTime());
            comisionistaExterno.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            List<ComisionistaExterno> lsComisionistaExterno =
                    comisionistaExternoService.buscar(comisionistaExterno.getDesccomisionista());

            if (!lsComisionistaExterno.isEmpty()) {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarComisionistaExternoController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else {
                if (comisionistaExterno.getComisionistaexternoId() == null) {
                    comisionistaExternoService.suscribir(comisionistaExterno);
                    comisionistaExternoList.addItem(comisionistaExterno);
                } else {
                    comisionistaExternoService.actualizacion(comisionistaExterno);
                    comisionistaExternoList.updateItem(comisionistaExterno);
                }

                Messagebox.show(
                        Labels.getLabel("editarComisionistaExternoController.MSG.suscribirOK"),
                        Labels.getLabel("editarComisionistaExternoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarComisionistaExternoController.MSG.borrarPergunta"),
                    Labels.getLabel("editarComisionistaExternoController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                comisionistaExternoService.borrar(comisionistaExterno);

                Messagebox.show(
                        Labels.getLabel("editarComisionistaExternoController.MSG.borrarOK"),
                        Labels.getLabel("editarComisionistaExternoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                comisionistaExternoList.removeItem(comisionistaExterno);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
